/*	Ballz.h
 *
 *	Robert Rose June 17, 2005
 *
 *	Copyright (c) 2005 Robert Rose
 *
 *	Permission is granted to do whatever you want with this code as long
 *	as the author is given due credit.
 *	
 */

#pragma once

#include <vector>

#include "NogredexDemoFrameListener.h"
#include "DebugGraphics.h"

#include "Agent.h"

using namespace std;


class Ballz : public NogredexDemoFrameListener
{

public:
    Ballz(RenderWindow *w, Camera *c, SceneManager *sceneMgr);
	~Ballz();

    bool frameStarted(const FrameEvent &evt);

	void updateStats();
	void showOverlay(bool show);

private:
	void destroy();

	void createScene0();
	void createScene1();
	void createScene2();
	void createScene3();


	CAgent *_player;

	vector<CAgent *> _agents;
	vector<CAgent *> _obstacles;

    DebugGraphics *mDebug;

	AgentSearchStrategy _strategy;

	Vector3 _desiredcamera;

	bool _ballmove;
};
